diff --git a/test/periphery-lld/bq27500_v1/aos_test_bq27500.h b/test/periphery-lld/bq27500_v1/aos_test_bq27500.h
new file mode 100644
index 0000000..489a8e8
--- /dev/null
+++ b/test/periphery-lld/bq27500_v1/aos_test_bq27500.h
@@ -0,0 +1,81 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_BQ2750_H
+#define AMIROOS_TEST_BQ2750_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_bq27500.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   Pointer to the driver to use.
+   */
+  BQ27500Driver *driver;
+
+  /**
+   * @brief   Timeout value (in us);
+   */
+  apalTime_t timeout;
+} aos_test_bq27500data_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestBq27500Func(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_BQ2750_H */
diff --git a/test/periphery-lld/bq27500_v1_bq241xx_v1/aos_test_bq27500_bq241xx.c b/test/periphery-lld/bq27500_v1_bq241xx_v1/aos_test_bq27500_bq241xx.c
new file mode 100644
index 0000000..0f2836e
--- /dev/null
+++ b/test/periphery-lld/bq27500_v1_bq241xx_v1/aos_test_bq27500_bq241xx.c
@@ -0,0 +1,156 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_bq27500_bq241xx.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+
+aos_testresult_t aosTestBq27500Bq241xxFunc(BaseSequentialStream *stream, const aos_test_t *test)
+{
+  aosDbgCheck(test->data != NULL && ((aos_test_bq27500bq241xxdata_t*)test->data)->bq27500 != NULL && ((aos_test_bq27500bq241xxdata_t*)test->data)->bq241xx != NULL);
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  uint32_t status;
+  uint16_t dst;
+  bq27500_lld_flags_t flags;
+  bq27500_lld_batgood_t bg;
+  bq241xx_lld_enable_t charger_enabled;
+  uint32_t sleeptime_s;
+  bq241xx_lld_charge_state_t charge;
+
+  chprintf(stream, "check for battery...\n");
+  status = bq27500_lld_std_command(((aos_test_bq27500bq241xxdata_t*)test->data)->bq27500, BQ27500_LLD_STD_CMD_Flags, &dst, ((aos_test_bq27500bq241xxdata_t*)test->data)->timeout);
+  flags.value = dst;
+  chprintf(stream, "\t\tbattery detected: %s\n", flags.content.bat_det ? "yes" : "no");
+  chprintf(stream, "\t\tbattery fully charged: %s\n", flags.content.fc ? "yes" : "no");
+  status |= bq27500_lld_read_batgood(((aos_test_bq27500bq241xxdata_t*)test->data)->bq27500, &bg);
+  chprintf(stream, "\t\tbattery good: %s\n", (bg == BQ27500_LLD_BATTERY_GOOD) ? "yes" : "no");
+  if (status == APAL_STATUS_SUCCESS) {
+    if (!flags.content.bat_det) {
+      aosTestPassedMsg(stream, &result, "no battery detected, aborting\n");
+      return result;
+    } else if (!bg) {
+      aosTestPassedMsg(stream, &result, "battery damaged, aborting\n");
+      return result;
+    } else {
+      aosTestPassed(stream, &result);
+    }
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X; aborting\n", status);
+    return result;
+  }
+
+  chprintf(stream, "get current charger setting...\n");
+  status = bq241xx_lld_get_enabled(((aos_test_bq27500bq241xxdata_t*)test->data)->bq241xx, &charger_enabled);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassedMsg(stream, &result, "currently %s\n", (charger_enabled == BQ241xx_LLD_ENABLED) ? "enabled" : "disabled");
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  // disable/enable charger
+  for (uint8_t iteration = 0; iteration < 2; ++iteration) {
+    if (charger_enabled == BQ241xx_LLD_ENABLED) {
+      sleeptime_s = 120;
+      chprintf(stream, "disable charger...\n");
+      status = bq241xx_lld_set_enabled(((aos_test_bq27500bq241xxdata_t*)test->data)->bq241xx, BQ241xx_LLD_DISABLED);
+      aosThdSSleep(1);
+      status |= bq241xx_lld_get_enabled(((aos_test_bq27500bq241xxdata_t*)test->data)->bq241xx, &charger_enabled);
+      status |= (charger_enabled == BQ241xx_LLD_DISABLED) ? 0x0000 : 0x0100;
+      for (uint32_t s = 0; s < sleeptime_s; ++s) {
+        int nchars = chprintf(stream, "%us / %us", s, sleeptime_s);
+        aosThdSSleep(1);
+        for (int c = 0; c < nchars; ++c) {
+          chprintf(stream, "\b \b");
+        }
+      }
+      status |= bq241xx_lld_get_charge_status(((aos_test_bq27500bq241xxdata_t*)test->data)->bq241xx, &charge);
+      chprintf(stream, "\t\tcharge status: %scharging\n", (charge == BQ241xx_LLD_CHARGING) ? "" : "not ");
+      status |= bq27500_lld_std_command(((aos_test_bq27500bq241xxdata_t*)test->data)->bq27500, BQ27500_LLD_STD_CMD_TimeToFull, &dst, ((aos_test_bq27500bq241xxdata_t*)test->data)->timeout);
+      if (status == APAL_STATUS_SUCCESS) {
+        if (dst == 0xFFFF || dst == 0) {
+          aosTestPassedMsg(stream, &result, "battery %sfull\n", flags.content.fc ? "" : "not ");
+        } else {
+          aosTestFailedMsg(stream, &result, "battery %sfull but charging (TTF = %umin)\n", flags.content.fc ? "" : "not ", dst);
+        }
+      } else {
+        aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+      }
+    }
+    else { /* charger_enabled != BQ241xx_LLD_ENABLED */
+      sleeptime_s = 90;
+      chprintf(stream, "enable charger...\n");
+      status = bq241xx_lld_set_enabled(((aos_test_bq27500bq241xxdata_t*)test->data)->bq241xx, BQ241xx_LLD_ENABLED);
+      aosThdSSleep(1);
+      status |= bq241xx_lld_get_enabled(((aos_test_bq27500bq241xxdata_t*)test->data)->bq241xx, &charger_enabled);
+      status |= (charger_enabled == BQ241xx_LLD_ENABLED) ? 0x0000 : 0x0100;
+      for (uint32_t s = 0; s < sleeptime_s; ++s) {
+        int nchars = chprintf(stream, "%us / %us", s, sleeptime_s);
+        aosThdSSleep(1);
+        for (int c = 0; c < nchars; ++c) {
+          chprintf(stream, "\b \b");
+        }
+      }
+      status |= bq241xx_lld_get_charge_status(((aos_test_bq27500bq241xxdata_t*)test->data)->bq241xx, &charge);
+      chprintf(stream, "\t\tcharge status: %scharging\n", (charge == BQ241xx_LLD_CHARGING) ? "" : "not ");
+      status |= bq27500_lld_std_command(((aos_test_bq27500bq241xxdata_t*)test->data)->bq27500, BQ27500_LLD_STD_CMD_TimeToFull, &dst, ((aos_test_bq27500bq241xxdata_t*)test->data)->timeout);
+      if (status == APAL_STATUS_SUCCESS) {
+        if (((dst == 0xFFFF || dst == 0) && flags.content.fc) || (!(dst == 0xFFFF || dst == 0) && !flags.content.fc)) {
+          aosTestPassedMsg(stream, &result, "battery %sfull and %scharging (TTF = %umin)\n", flags.content.fc ? "" : "not ", (dst != 0xFFFF || dst != 0) ? "" : "not ", dst);
+        } else {
+          aosTestFailedMsg(stream, &result, "battery %sfull and %scharging (TTF = %umin)\n", flags.content.fc ? "" : "not ", (dst != 0xFFFF || dst != 0) ? "" : "not ", dst);
+        }
+      } else {
+        aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+      }
+    }
+
+    bq241xx_lld_get_enabled(((aos_test_bq27500bq241xxdata_t*)test->data)->bq241xx, &charger_enabled);
+  }
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/test/periphery-lld/bq27500_v1_bq241xx_v1/aos_test_bq27500_bq241xx.h b/test/periphery-lld/bq27500_v1_bq241xx_v1/aos_test_bq27500_bq241xx.h
new file mode 100644
index 0000000..321deb3
--- /dev/null
+++ b/test/periphery-lld/bq27500_v1_bq241xx_v1/aos_test_bq27500_bq241xx.h
@@ -0,0 +1,87 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_BQ27500_BQ241xx_H
+#define AMIROOS_TEST_BQ27500_BQ241xx_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_bq27500.h>
+#include <alld_bq241xx.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   BQ27500 driver to use.
+   */
+  BQ27500Driver* bq27500;
+
+  /**
+   * @brief   BQ24103A driver to use.
+   */
+  BQ241xxDriver* bq241xx;
+
+  /**
+   * @brief   Timeout value (in us).
+   */
+  apalTime_t timeout;
+} aos_test_bq27500bq241xxdata_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestBq27500Bq241xxFunc(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_BQ27500_BQ241xx_H */
diff --git a/test/periphery-lld/button_v1/aos_test_button.c b/test/periphery-lld/button_v1/aos_test_button.c
new file mode 100644
index 0000000..a857206
--- /dev/null
+++ b/test/periphery-lld/button_v1/aos_test_button.c
@@ -0,0 +1,103 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_button.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+#define INTERRUPT_EVENT_ID            1
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+/**
+ * @brief   Button test function.
+ *
+ * @param[in] stream  Stream for input/output.
+ * @param[in] test    Test object.
+ *
+ * @return            Test result value.
+ */
+aos_testresult_t aosTestButtonFunc(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck(test->data != NULL &&
+      ((aos_test_buttondata_t*)test->data)->button != NULL &&
+      ((aos_test_buttondata_t*)test->data)->evtsource != NULL);
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  int32_t status = AOS_OK;
+  unsigned int count = 0;
+  button_lld_state_t bstate;
+  event_listener_t evtlistener;
+  aos_timestamp_t tcurrent, tend;
+
+  chprintf(stream, "test interrupts for ten seconds...\n");
+  chEvtRegister(((aos_test_buttondata_t*)test->data)->evtsource, &evtlistener, INTERRUPT_EVENT_ID);
+  aosSysGetUptime(&tend);
+  tend += 10 * MICROSECONDS_PER_SECOND;
+  do {
+    const eventmask_t emask = chEvtWaitOneTimeout(EVENT_MASK(INTERRUPT_EVENT_ID), chTimeUS2I(MICROSECONDS_PER_SECOND));
+    const eventflags_t eflags = chEvtGetAndClearFlags(&evtlistener);
+    status |= button_lld_get(((aos_test_buttondata_t*)test->data)->button, &bstate);
+    if (emask == EVENT_MASK(INTERRUPT_EVENT_ID) &&
+        eflags == ((aos_test_buttondata_t*)test->data)->evtflags) {
+      // a correct event was detected
+      chprintf(stream, "\t\tinterrupt detected: %s\n", (bstate == BUTTON_LLD_STATE_PRESSED) ? "pressed" : "released");
+      ++count;
+    } else {
+      // no button event was detected (usually timeout)
+      chprintf(stream, "\t\twaiting for event...\n");
+    }
+    aosSysGetUptime(&tcurrent);
+  } while (tcurrent < tend);
+  chEvtUnregister(((aos_test_buttondata_t*)test->data)->evtsource, &evtlistener);
+  if (status == APAL_STATUS_OK && count > 0) {
+    aosTestPassedMsg(stream, &result, "%u events detected\n", count);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X; %u\n", status, count);
+  }
+
+  aosTestInfoMsg(stream,"driver object memory footprint: %u bytes\n", sizeof(ButtonDriver));
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/test/periphery-lld/button_v1/aos_test_button.h b/test/periphery-lld/button_v1/aos_test_button.h
new file mode 100644
index 0000000..0b076cb
--- /dev/null
+++ b/test/periphery-lld/button_v1/aos_test_button.h
@@ -0,0 +1,86 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TESTS_BUTTON_H
+#define AMIROOS_TESTS_BUTTON_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_button.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   Pointer to the driver to use.
+   */
+  ButtonDriver* button;
+
+  /**
+   * @brief   Event source to listen to.
+   */
+  event_source_t* evtsource;
+
+  /**
+   * @brief   Event flags to watch.
+   */
+  eventflags_t evtflags;
+} aos_test_buttondata_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestButtonFunc(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TESTS_BUTTON_H */
diff --git a/test/test.mk b/test/test.mk
new file mode 100644
index 0000000..4c48778
--- /dev/null
+++ b/test/test.mk
@@ -0,0 +1,34 @@
+################################################################################
+# AMiRo-OS is an operating system designed for the Autonomous Mini Robot       #
+# (AMiRo) platform.                                                            #
+# Copyright (C) 2016..2019  Thomas Schöpping et al.                            #
+#                                                                              #
+# This program is free software: you can redistribute it and/or modify         #
+# it under the terms of the GNU General Public License as published by         #
+# the Free Software Foundation, either version 3 of the License, or            #
+# (at your option) any later version.                                          #
+#                                                                              #
+# This program is distributed in the hope that it will be useful,              #
+# but WITHOUT ANY WARRANTY; without even the implied warranty of               #
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                #
+# GNU General Public License for more details.                                 #
+#                                                                              #
+# You should have received a copy of the GNU General Public License            #
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.        #
+#                                                                              #
+# This research/work was supported by the Cluster of Excellence Cognitive      #
+# Interaction Technology 'CITEC' (EXC 277) at Bielefeld University, which is   #
+# funded by the German Research Foundation (DFG).                              #
+################################################################################
+
+
+
+# absolute path to this directory
+AMIROOS_TEST_DIR := $(dir $(lastword $(MAKEFILE_LIST)))
+
+# include path
+AMIROOS_TEST_INC =
+
+# C sources
+AMIROOS_TEST_CSRC = $(wildcard $(AMIROOS_TEST_INC:%=%/*.[Cc]))
+
